#include "util.hh"

void 
toBinStr( unsigned int val, int len, char *out )
{
  unsigned int mask = 0x00000001 << ( len - 1 );
  strcpy( out, "" );
  for ( register int i = 0; i < len; i++, mask = mask >> 1 )
  {
    if ( mask & val )
    {
      strcat( out, "1" );
    }
    else
    {
      strcat( out, "0" );
    }
  }
}

unsigned int 
toInteger( char *str, int base )
{
  int sum = 0;
   
  for ( register int i = 0; i < strlen( str ); i++ )
  {
    if ( base == 16 )
    {
      //sum *= 16;
      sum = sum << 4;
      switch( str[ i ] )
      {
      case '0' : break;
      case '1' : sum += 1; break;
      case '2' : sum += 2; break;
      case '3' : sum += 3; break;
      case '4' : sum += 4; break;
      case '5' : sum += 5; break;
      case '6' : sum += 6; break;
      case '7' : sum += 7; break;
      case '8' : sum += 8; break;
      case '9' : sum += 9; break;
      case 'a' :
      case 'A' : sum += 10; break;  
      case 'b' :
      case 'B' : sum += 11; break;  
      case 'c' :
      case 'C' : sum += 12; break;  
      case 'd' :
      case 'D' : sum += 13; break;  
      case 'e' :
      case 'E' : sum += 14; break;  
      case 'f' :
      case 'F' : sum += 15; break;
      default  : break;
      }
    }  
    else if ( base == 10 )
    {
      sum *= 10;
      switch( str[ i ] )
	{
	case '0' : break;
	case '1' : sum += 1; break;
	case '2' : sum += 2; break;
	case '3' : sum += 3; break;
	case '4' : sum += 4; break;
	case '5' : sum += 5; break;
	case '6' : sum += 6; break;
	case '7' : sum += 7; break;
	case '8' : sum += 8; break;
	case '9' : sum += 9; break;
	default  : break;
	}
    }  
    else if ( base == 8 )
    {
      //sum *= 8;
      sum = sum << 3;
      switch( str[ i ] )
      {
      case '0' : break;
      case '1' : sum += 1; break;
      case '2' : sum += 2; break;
      case '3' : sum += 3; break;
      case '4' : sum += 4; break;
      case '5' : sum += 5; break;
      case '6' : sum += 6; break;
      case '7' : sum += 7; break;
      default  : break;
      }
    }  
    else if ( base == 2 )
    {
      //sum *= 2;
      sum = sum << 1;
      switch( str[ i ] )
      {
      case '0' : break;
      case '1' : sum += 1; break;
      default  : break;
      }
    }
  }     
  return sum;
}
